methods                package:utils                R Documentation

List Methods for S3 Generic Functions or Classes

Description:

     List all available methods for an S3 generic function, or all
     methods for a class.

Usage:

     methods(generic.function, class)

Arguments:

generic.function: a generic function, or a character string naming a
          generic function.

   class: a symbol or character string naming a class: only used if
          'generic.function' is not supplied.

Details:

     Function 'methods' can be used to find out about the methods for a
     particular generic function or class.  The functions listed are
     those which _are named like methods_ and may not actually be
     methods (known exceptions are discarded in the code).  Note that
     the listed methods may not be user-visible objects, but often help
     will be available for them.

     If 'class' is used, we check that a matching generic can be found
     for each user-visible object named.

Value:

     An object of class '"MethodsFunction"', a character vector of
     function names with an '"info"' attribute. There is a 'print'
     method which marks with an asterisk any methods which are not
     visible: such functions can be examined by 'getS3method' or
     'getAnywhere'.

     The '"info"' attribute is a data frame, currently with a logical
     column, 'visible' and a factor column 'from' (indicating where the
     methods were found).

Note:

     This scheme is called _S3_ (S version 3).  For new projects, it is
     recommended to use the more flexible and robust _S4_ scheme
     provided in the 'methods' package.  Functions can have both S3 and
     S4 methods, and function 'showMethods' will list the S4 methods
     (possibly none).

     The original 'methods' function was written by Martin Maechler.

References:

     Chambers, J. M. (1992) _Classes and methods: object-oriented
     programming in S._ Appendix A of _Statistical Models in S_ eds J.
     M. Chambers and T. J. Hastie, Wadsworth & Brooks/Cole.

See Also:

     'S3Methods', 'class', 'getS3method'

Examples:

     methods(summary)
     methods(class = "aov")
     methods("[[")    ##- does not list the C-internal ones...
     methods("$")     # currently none
     methods("$<-")   # replacement function
     methods("+")     # binary operator
     methods("Math")  # group generic
     ## Not run: 
     methods(print)
     ## End(Not run)

